#!/usr/bin/python
# -*- coding: utf-8 -*-

# DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#                    Version 2, December 2004
#
# Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
#
# Everyone is permitted to copy and distribute verbatim or modified
# copies of this license document, and changing it is allowed as long
# as the name is changed.
#
#            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
#
#  0. You just DO WHAT THE FUCK YOU WANT TO.


import pygame
from numpy import *
import random
pygame.init()
xmin=46
xmax=754
ymin=42
ymax=378
screen = pygame.display.set_mode([800,420])
pygame.display.set_caption('Chaothic Billiard')

fondo= pygame.image.load("chabill.png")
screen.blit(fondo,(0,0))
pygame.display.update()

espera=True
mainloop =  True
pygame.event.get()
while espera:
	for event in pygame.event.get():
			if event.type == pygame.MOUSEBUTTONUP:
				espera = False
			if event.type == pygame.QUIT:
				mainloop = False


fase=1
fps = 50
clock = pygame.time.Clock() 
tablero= pygame.image.load("billar.jpg").convert()
azul = pygame.image.load("bolazul.png")
roja = pygame.image.load("bolaroja.png")
r=10
g=0.1
frr=0.002
fr=0.9955
frq=0.
t=0
vx=1
vy=0

class Bola:
	def __init__(self,screen=screen,r=10,dibujo=azul):
		self.dibujo=dibujo
		self.screen=screen
		self.vel=array([0.,0.])
		self._pos=array([100.,100.])
		self.r=r
	def color(self,color):
		self.dibujo=color
	def pos(self,x=100000,y=100000):
		if x!=100000 and y!=100000:
			self._pos[0]=x
			self._pos[1]=y
		screen.blit(self.dibujo,(self._pos[0],self._pos[1]))
	def paso(self):
		self.vel*=fr
		self._pos+=self.vel
		if fase == 1:
			if (self._pos[0] < xmin): #or (self._pos[0] >= xmax-2.*self.r) :
				self._pos[0]=xmin
				self.vel[0]*=-1
				self.vel-=frr
			if (self._pos[0] > xmax-2.*self.r) :
				self._pos[0]=xmax-2.*self.r
				self.vel[0]*=-1
				self.vel-=frr
			if (self._pos[1] < ymin):# or (self._pos[1] >= ymax-2.*self.r) :
				self._pos[1]=ymin
				self.vel[1]*=-1.
				self.vel-=frr
			if (self._pos[1] > ymax-2.*self.r) :
				self._pos[1]=ymax-2.*self.r
				self.vel[1]*=-1.
				self.vel-=frr
		
		screen.blit(self.dibujo,(self._pos[0],self._pos[1]))
	def pasoatras(self):
		self._pos-=self.vel


def mag(v1):
	return sqrt(sum(v1**2))
def mag2(v1):
	return sum(v1**2)
def norm(v1):
	return v1/mag(v1)

def colisiona(a,b):
	direction=norm(b._pos-a._pos)
	di=dot(a.vel,direction)
	dj=dot(b.vel,direction)
	exchange=dj-di
	a.vel+= exchange*direction
	a.vel*=fr
	b.vel-= exchange*direction
	b.vel*=fr
	overlap=a.r*2.-(mag(a._pos-b._pos))
	a._pos-= overlap*direction
	b._pos+= overlap*direction


def colocabolas():
	bolas=[]
	bolas.append(Bola(screen,10,azul))
	bolas[-1].pos(((xmax-xmin)/4),(ymax-ymin)/2+ymin-10)
	bolas.append(Bola(screen,10,roja))
	bolas[-1].pos((3*(xmax-xmin)/4),(ymax-ymin)/2-10)
	bolas.append(Bola(screen,10,roja))
	bolas[-1].pos((3*(xmax-xmin)/4),(ymax-ymin)/2+2*ymin-10)
	
	return bolas

bolas=colocabolas()

font = pygame.font.Font(None, 36)
marcador=font.render("0", 1, (255, 255, 0))


def apunta():
	mainloopa=True
	flecha=pygame.draw.line(screen, [0,0,0], bolas[0]._pos, pygame.mouse.get_pos())
	mpos=bolas[0]._pos
	pygame.event.get()
	while mainloopa:
		tick_time = clock.tick(fps*0.5)
		for event in pygame.event.get():
			if event.type == pygame.MOUSEBUTTONUP:
				mpos=pygame.mouse.get_pos()
				mainloopa=False
			if event.type == pygame.QUIT:
				raise SystemExit
		screen.blit(tablero,(0,0))
		for b in bolas:
			b.pos()
		v=array(pygame.mouse.get_pos())-array([bolas[0].r,bolas[0].r])-bolas[0]._pos
		flecha=pygame.draw.line(screen, [100+5*mag(v/(mag2(v)+500)*1000),0,0], [bolas[0]._pos[0]+bolas[0].r,bolas[0]._pos[1]+bolas[0].r], pygame.mouse.get_pos(),3)
		screen.blit(marcador,[100,0])
		pygame.display.update()
	return v/(mag2(v)+500)*1000

def disparo(vel):
	mainloopd=True
	bolas[0].vel=vel
	caram=[]
	while mainloopd:
		veltot=0
		for i in bolas:
			veltot+=mag2(i.vel)
		if veltot < 0.05:
			mainloopd=False
		tick_time = clock.tick(fps)
		#t+=1
		for event in pygame.event.get():
			if event.type == pygame.QUIT:
				raise SystemExit
		bbolas=arange(len(bolas))
		bbolas=delete(bbolas,[0])
		abolas=arange(len(bolas))
		abolas=delete(abolas,[-1])
		for b in bolas:
			b.paso()
		for j in abolas:
			for i in bbolas:
				if mag(bolas[i]._pos-bolas[j]._pos) <= (bolas[j].r+bolas[i].r) :
					colisiona(bolas[j],bolas[i])
					caram.append([i,j])
			bbolas=delete(bbolas,[0])
		pygame.display.update()
		screen.blit(tablero,(0,0))
		screen.blit(marcador,[100,0])
	for b in bolas:
		b.vel*=0.
	return caram

mainloop=True
puntuacion=0
while mainloop:
	carambolas=disparo(apunta())
	
	if len(carambolas) == 0 :
		if puntuacion > 0:
			puntuacion-=1
	elif len(carambolas) == 1:
		puntuacion-=0
	elif (carambolas[0] == [1,0] and carambolas[1] == [2,1]) or (carambolas[0] == [2,0] and carambolas[1] == [2,1]): 
		puntuacion+=1
	elif (carambolas[0] == [1,0] and carambolas[1] == [2,0]) or (carambolas[0] == [2,0] and carambolas[1] == [1,0]): 
		puntuacion+=2
	marcador=font.render(str(puntuacion), 1, (255, 255, 0))
